// OTMDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "OTM.h"
#include "OTMDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "DataReader.h"
#include "ChooseDirectory.h"

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COTMDlg Dialogfeld

COTMDlg::COTMDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COTMDlg::IDD, pParent)
{
	m_opengl = NULL;
	m_panel  = NULL;

	
	//{{AFX_DATA_INIT(COTMDlg)
		// HINWEIS: Der Klassenassistent fgt hier Member-Initialisierung ein
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

/////////////////////////////////////////////////////////////////////////////

COTMDlg::~COTMDlg()
{
	m_fileElements->clear();
	delete m_fileElements;
	delete m_opengl;
	delete m_panel;
}

/////////////////////////////////////////////////////////////////////////////

void COTMDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COTMDlg)
		// HINWEIS: Der Klassenassistent fgt an dieser Stelle DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(COTMDlg, CDialog)
	//{{AFX_MSG_MAP(COTMDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_COMMAND(ID_OPEN_XML, OnOpenXml)
	ON_COMMAND(ID_OPEN_DIR, OnOpenDir)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_WM_MOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

BOOL COTMDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// prevent from flickering when resized
	ModifyStyle(0, WS_CLIPCHILDREN);

	// now rect is used to store the current client area
	CRect m_rect;
	GetClientRect(m_rect);

	m_opengl = new COpenGL(this);
	m_panel = new CPanel(this);
	
	CRect rPanel;
	CRect rOpenGL;

	m_panel->GetWindowRect(rPanel);
	ScreenToClient(rPanel);

	m_panel->MoveWindow(rPanel.left,0,rPanel.Width(),rPanel.Height() - 2);
	m_opengl->MoveWindow(0,0,rPanel.left,m_rect.Height() - 2);

	// data container
	m_fileElements = new CFileElement();
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

/////////////////////////////////////////////////////////////////////////////

void COTMDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

/////////////////////////////////////////////////////////////////////////////.

void COTMDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

/////////////////////////////////////////////////////////////////////////////
// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR COTMDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/////////////////////////////////////////////////////////////////////////////

void COTMDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// important to do noting if the window is minimized
	if (cx < 100) return;
	if (cy < 20) return;

	// resize the panel
	if (m_panel != NULL)		{	m_panel->Resize();	}
	// resize opengl window
	if (m_opengl != NULL)		{	m_opengl->Resize();	}	
}

/////////////////////////////////////////////////////////////////////////////

void COTMDlg::OnOpenXml() 
{
	m_panel->ActivateControls(false);

	// TODO: read XML-File

	m_panel->ActivateControls(true);
		
}

/////////////////////////////////////////////////////////////////////////////

void COTMDlg::OnOpenDir() 
{
	m_panel->ActivateControls(false);

	CChooseDirectory *pChooseDir = new CChooseDirectory(this);
	if (pChooseDir->DoModal() == IDOK)
	{
		//CString strSearch = "C:\\Programme\\Gemeinsame Dateien";
		CString strSearch = pChooseDir->GetDirectory();
		CFileStatus FileStatus;

		if (CFile::GetStatus(strSearch, FileStatus) == FALSE)
		{
			AfxMessageBox("Directory not valid: " + strSearch);
			delete pChooseDir;
			return;
		}

		// test if this is a directory
		if ((FileStatus.m_attribute & 0x10) != 0)
		{
			CDataReader *dr = new CDataReader();
			m_fileElements->clear();
			m_fileElements->setRoot(strSearch);
			dr->readDirectory(strSearch, m_fileElements);
			delete dr;

			int nDepth = m_fileElements->getDepth(m_fileElements, 0);
			m_panel->SetScrollingRange(nDepth);
			m_panel->ActivateControls(true);

			// apply the new data and render
			m_opengl->setFileElement(m_fileElements);
			m_opengl->render();
		}
		else 
		{
			AfxMessageBox(strSearch + " is not a valid directory.");
		}
	}

	delete pChooseDir;
}

/////////////////////////////////////////////////////////////////////////////

void COTMDlg::OnFileExit() 
{
	exit(0);
}

/////////////////////////////////////////////////////////////////////////////

void COTMDlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);
	// resize the panel
	if (m_panel != NULL)		{	m_panel->Resize();	}
	// resize opengl window
	if (m_opengl != NULL)		{	m_opengl->Resize();	}
	
}


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////EOF
