// OTMDlg.h : Header-Datei
//

#if !defined(AFX_OTMDLG_H__63FB6E06_8832_4222_9626_B80A52A29117__INCLUDED_)
#define AFX_OTMDLG_H__63FB6E06_8832_4222_9626_B80A52A29117__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "OpenGL.h"
#include "Panel.h"
#include "FileElement.h"

/////////////////////////////////////////////////////////////////////////////
// COTMDlg Dialogfeld

class COTMDlg : public CDialog
{
// Konstruktion
public:
	COTMDlg(CWnd* pParent = NULL);	// Standard-Konstruktor	
	~COTMDlg();

	// subwindows
	COpenGL  *m_opengl;
	CPanel   *m_panel;

// Dialogfelddaten
	//{{AFX_DATA(COTMDlg)
	enum { IDD = IDD_OTM_DIALOG };
		// HINWEIS: der Klassenassistent fgt an dieser Stelle Datenelemente (Members) ein
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(COTMDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	HICON m_hIcon;

	CFileElement *m_fileElements;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(COTMDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnOpenXml();
	afx_msg void OnOpenDir();
	afx_msg void OnFileExit();
	afx_msg void OnMove(int x, int y);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_OTMDLG_H__63FB6E06_8832_4222_9626_B80A52A29117__INCLUDED_)
