#if !defined(AFX_PANEL_H__0BA312AE_06B1_4284_9768_051B63416300__INCLUDED_)
#define AFX_PANEL_H__0BA312AE_06B1_4284_9768_051B63416300__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Panel.h : Header-Datei
//
#include "stdafx.h"
#include "FileElement.h"


/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CPanel 

class CPanel : public CDialog
{
// Konstruktion
public:
	CPanel(CWnd* pParent = NULL);	// Standard-Konstruktor
	virtual ~CPanel();

	// Activate/Deactivate Controls
	void ActivateControls(bool bActivate);

	// resize Window
	void Resize();

	// display FileElement info
	void WriteFileElementInfo(CFileElement *fe);

	// setScrollRange
	void SetScrollingRange(int nMax);

// Dialogfelddaten
	//{{AFX_DATA(CPanel)
	enum { IDD = IDD_PANEL };
	CButton	m_btnColorMin;
	CButton	m_btnColorMax;
	CSliderCtrl	m_slHierarchy;
	CEdit	m_editFileAttribute;
	CComboBox	m_comboColorByAttribute;
	CButton	m_btnRandomize;
	//}}AFX_DATA


// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CPanel)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	// Generierte Nachrichtenzuordnungsfunktionen
	//{{AFX_MSG(CPanel)
	virtual BOOL OnInitDialog();
	afx_msg void OnBtnRandom();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnRadioPivotByMiddle();
	afx_msg void OnRadioPivotBySize();
	afx_msg void OnRadioSliceAndDice();
	afx_msg void OnRadioSquarified();
	afx_msg void OnSelchangeCmbColorByAttr();
	afx_msg void OnButtonColorMin();
	afx_msg void OnButtonColorMax();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void SetColor(int nDlgID, COLORREF rColor);

	CWnd  *m_pParent;

	COLORREF m_cMinCol;
	COLORREF m_cMaxCol;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_PANEL_H__0BA312AE_06B1_4284_9768_051B63416300__INCLUDED_
