// DataReader.cpp: Implementierung der Klasse CDataReader.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "stdafx.h"
#include "DataReader.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#include <direct.h>

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDataReader::CDataReader()
{

}

//////////////////////////////////////////////////////////////////////

CDataReader::~CDataReader()
{

}

//////////////////////////////////////////////////////////////////////

void CDataReader::readDirectory(CString strRootDir, CFileElement *fileElement)
{
	if (_chdir(strRootDir.GetBuffer(strRootDir.GetLength())) == 0)
	{
		// init the FileFind object
		CFileFind ff;
		if (ff.FindFile() == 0) return;

		bool cont = true;
		while (cont) 
		{
			if (ff.FindNextFile() == 0) cont = false;
			if (ff.IsDots() != 0) continue;

			// fetch file-attributes
			CString strName = ff.GetFileName();
			CString strRoot = ff.GetRoot();
			CTime tCreation, tLastModified;
			ff.GetCreationTime(tCreation);
			ff.GetLastWriteTime(tLastModified);
			_int64 nSize = ff.GetLength64();
			bool bIsDir = (ff.IsDirectory() != 0);

			//TRACE("READER: %s-->%s\n", strRoot, strName);
			
			// addFile
			fileElement->add(strName, strRoot, tCreation, tLastModified, nSize, bIsDir);

			// if this is a directoy -> recursion
			if (bIsDir) readDirectory(ff.GetFilePath(), fileElement);

		}

		ff.Close();
	}
	else
		TRACE("ERROR: %s\n", strRootDir);
}

//////////////////////////////////////////////////////////////////////

void CDataReader::readXML(CString strXML, CFileElement *fileElement)
{

}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////EOF
